#!/usr/bin/perl 
use strict;

### Since file location can be rather random, we should make it easy to set.
$location = "CHANGE ME! - This should be where ever your mp3s are stored. Eg: /mnt/cdrom/mp3";

### Set some other variables.
my $value;
my $file;
my $displayfile;
my $whatisit;

### Decode URL values into $file
foreach $value ($ENV{'QUERY_STRING'}) {
 $value =~ tr/+/ /;
 $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
 $file = $value;
}

### Sometimes people might arrive here in strange ways that would cause them to not have a HTTP_REFERER.
### If that's the case, let's set a fake one, just so strange things do not happen.
if ( $ENV{'HTTP_REFERER'} eq "" ) { 
 $ENV{'HTTP_REFERER'} = "/";
}
  

### Print out our header. 
print "Content-type: text/html\n\n";
print "<HTML><HEAD>\n";
print "<LINK rel=\"stylesheet\" href=\"/Mp3.css\" type=\"text/css\">\n";
print "<TITLE>Mp3 Database v6.4</TITLE>\n";
print "</HEAD><BODY>\n";
print "<META HTTP-EQUIV=Refresh CONTENT=2;URL=$ENV{'HTTP_REFERER'}>\n";
print "<CENTER>\n";
print "<BR>\n\n";

### Make sure we have something to do, shall we? 
if ( $file ne "" ) {
 ### Let's preprocess our $file to remove some 'exploit' code.  Do this before setting $displayfile, so
 ### we don't do the same thing twice.  Turn them into harmless spaces.
 $file =~ s/\;/ /g;
 $file =~ s/\`/ /g;
 $file =~ s/\%/ /g;

 ### Now we want to create a variable that holds the filename before we visually kill it.
 ### Also add one more prettyness factor to $displayfile.
 $displayfile = $file;
 $displayfile =~ s/\.mp3//g;
 $displayfile =~ s/\.ogg//g;

 ### We also replace every character that might be in a mp3's name that could mess with the 
 ### shell, turning them into ?'s. 
 $file =~ s/[^a-zA-Z0-9\-\/.]/\?/g;

 if (!(-f "/tmp/mpg123.lock") && !(-f "/tmp/.mp3db.paused") ) {
  &play_file;
 } else {
  &queue_file;
 }
} else {
 print "<B>No file, or an invalid file was selected</B>\n";
}

print "</BODY></HTML>\n";

###               ###
### Sub-routines. ###
###               ###

sub play_file {
 ### Test $displayfile to find out if we have an MP3 or an OGG
 ### If the file extension isn't .mp3 or .ogg, let's run 'file'
 ### on it, and see what it has to say.
 if ( substr $displayfile, -3 =~ /mp3/i ) {
  system("./pmpg123 $location/$file \"$displayfile\" 0 1> /dev/null 2>&1 &");
  print "<B>mpg123 will be playing: <U>$displayfile</U></B>\n";
 } elsif ( substr $displayfile, -3 =~ /ogg/i ) {
  system("./pmpg123 $location/$file \"$displayfile\" 1 1> /dev/null 2>&1 &");
  print "<B>ogg123 will be playing: <U>$displayfile</U></B>\n";
 } else {
  $whatisit = `file $location/$file`;
  if ( $whatisit =~ /mp3/i ) {
   system("./pmpg123 $location/$file \"$displayfile\" 0 1> /dev/null 2>&1 &");
   print "<B>mpg123 will be playing: <U>$displayfile</U></B>\n";
  } elsif ( $whatisit =~ /ogg/i ) {
   system("./pmpg123 $location/$file \"$displayfile\" 1 1> /dev/null 2>&1 &");
   print "<B>ogg123 will be playing: <U>$displayfile</U></B>\n";
  } else {
   print "<B>There was a problem attempting to play the file.<BR>\n";
   print "$displayfile is an unknown audio type.</B><BR>\n";
  }
 }
}

sub queue_file {
	open (QUEUE_FILE, ">>queue.list") || die "Can't open queue-file.";
	print QUEUE_FILE "$location/$file \"$displayfile\"\n";
	close QUEUE_FILE;  
	print "<B><U>$displayfile</U> was added to the queue.</B>\n";
}
